t: translate SIGINT to an exit
[alt-git.git] / t / test-lib.sh
blobf4ba3ff972680065469f063c83ae90207bbab0b4
1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
19 ORIGINAL_TERM=$TERM
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
24 then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
29 else
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
34 if test -z "$TEST_OUTPUT_DIRECTORY"
35 then
36 # Similarly, override this to store the test-results subdir
37 # elsewhere
38 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
40 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
42 ################################################################
43 # It appears that people try to run tests without building...
44 "$GIT_BUILD_DIR/git" >/dev/null
45 if test $? != 1
46 then
47 echo >&2 'error: you do not seem to have built git yet.'
48 exit 1
51 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52 export PERL_PATH SHELL_PATH
54 # if --tee was passed, write the output not only to the terminal, but
55 # additionally to the file test-results/$BASENAME.out, too.
56 case "$GIT_TEST_TEE_STARTED, $* " in
57 done,*)
58 # do not redirect again
60 *' --tee '*|*' --va'*)
61 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $? > $BASE.exit) | tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
66 exit
68 esac
70 # For repeatability, reset the environment to known value.
71 LANG=C
72 LC_ALL=C
73 PAGER=cat
74 TZ=UTC
75 TERM=dumb
76 export LANG LC_ALL PAGER TERM TZ
77 EDITOR=:
78 # A call to "unset" with no arguments causes at least Solaris 10
79 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80 # deriving from the command substitution clustered with the other
81 # ones.
82 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
83 my @env = keys %ENV;
84 my $ok = join("|", qw(
85 TRACE
86 DEBUG
87 USE_LOOKUP
88 TEST
89 .*_TEST
90 PROVE
91 VALGRIND
92 UNZIP
93 PERF_
94 CURL_VERBOSE
95 ));
96 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
97 print join("\n", @vars);
99 unset XDG_CONFIG_HOME
100 unset GITPERLLIB
101 GIT_AUTHOR_EMAIL=author@example.com
102 GIT_AUTHOR_NAME='A U Thor'
103 GIT_COMMITTER_EMAIL=committer@example.com
104 GIT_COMMITTER_NAME='C O Mitter'
105 GIT_MERGE_VERBOSITY=5
106 GIT_MERGE_AUTOEDIT=no
107 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
108 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
110 export EDITOR
112 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
113 GIT_TRACE_BARE=1
114 export GIT_TRACE_BARE
116 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
117 then
118 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
119 export GIT_INDEX_VERSION
122 # Add libc MALLOC and MALLOC_PERTURB test
123 # only if we are not executing the test with valgrind
124 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
125 test -n "$TEST_NO_MALLOC_CHECK"
126 then
127 setup_malloc_check () {
128 : nothing
130 teardown_malloc_check () {
131 : nothing
133 else
134 setup_malloc_check () {
135 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
136 export MALLOC_CHECK_ MALLOC_PERTURB_
138 teardown_malloc_check () {
139 unset MALLOC_CHECK_ MALLOC_PERTURB_
143 : ${ASAN_OPTIONS=detect_leaks=0}
144 export ASAN_OPTIONS
146 # Protect ourselves from common misconfiguration to export
147 # CDPATH into the environment
148 unset CDPATH
150 unset GREP_OPTIONS
151 unset UNZIP
153 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
154 1|2|true)
155 echo "* warning: Some tests will not work if GIT_TRACE" \
156 "is set as to trace on STDERR ! *"
157 echo "* warning: Please set GIT_TRACE to something" \
158 "other than 1, 2 or true ! *"
160 esac
162 # Convenience
164 # A regexp to match 5 and 40 hexdigits
165 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
166 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
168 # Zero SHA-1
169 _z40=0000000000000000000000000000000000000000
171 # Line feed
172 LF='
175 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
176 # when case-folding filenames
177 u200c=$(printf '\342\200\214')
179 export _x05 _x40 _z40 LF u200c
181 # Each test should start with something like this, after copyright notices:
183 # test_description='Description of this test...
184 # This test checks if command xyzzy does the right thing...
186 # . ./test-lib.sh
188 unset color
189 while test "$#" -ne 0
191 case "$1" in
192 -d|--d|--de|--deb|--debu|--debug)
193 debug=t; shift ;;
194 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
195 immediate=t; shift ;;
196 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
197 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
199 shift; test "$#" -ne 0 || {
200 echo 'error: -r requires an argument' >&2;
201 exit 1;
203 run_list=$1; shift ;;
204 --run=*)
205 run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
206 -h|--h|--he|--hel|--help)
207 help=t; shift ;;
208 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
209 verbose=t; shift ;;
210 --verbose-only=*)
211 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
212 shift ;;
213 -q|--q|--qu|--qui|--quie|--quiet)
214 # Ignore --quiet under a TAP::Harness. Saying how many tests
215 # passed without the ok/not ok details is always an error.
216 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
217 --with-dashes)
218 with_dashes=t; shift ;;
219 --no-color)
220 color=; shift ;;
221 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
222 valgrind=memcheck
223 shift ;;
224 --valgrind=*)
225 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
226 shift ;;
227 --valgrind-only=*)
228 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
229 shift ;;
230 --tee)
231 shift ;; # was handled already
232 --root=*)
233 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
234 shift ;;
236 trace=t
237 verbose=t
238 shift ;;
240 echo "error: unknown test option '$1'" >&2; exit 1 ;;
241 esac
242 done
244 if test -n "$valgrind_only"
245 then
246 test -z "$valgrind" && valgrind=memcheck
247 test -z "$verbose" && verbose_only="$valgrind_only"
248 elif test -n "$valgrind"
249 then
250 verbose=t
253 error () {
254 say_color error "error: $*"
255 GIT_EXIT_OK=t
256 exit 1
259 say () {
260 say_color info "$*"
263 test "${test_description}" != "" ||
264 error "Test script did not set test_description."
266 if test "$help" = "t"
267 then
268 printf '%s\n' "$test_description"
269 exit 0
272 exec 5>&1
273 exec 6<&0
274 if test "$verbose" = "t"
275 then
276 exec 4>&2 3>&1
277 else
278 exec 4>/dev/null 3>/dev/null
281 test_failure=0
282 test_count=0
283 test_fixed=0
284 test_broken=0
285 test_success=0
287 test_external_has_tap=0
289 die () {
290 code=$?
291 if test -n "$GIT_EXIT_OK"
292 then
293 exit $code
294 else
295 echo >&5 "FATAL: Unexpected exit with code $code"
296 exit 1
300 GIT_EXIT_OK=
301 trap 'die' EXIT
302 trap 'exit $?' INT
304 # The user-facing functions are loaded from a separate file so that
305 # test_perf subshells can have them too
306 . "$TEST_DIRECTORY/test-lib-functions.sh"
308 # You are not expected to call test_ok_ and test_failure_ directly, use
309 # the test_expect_* functions instead.
311 test_ok_ () {
312 test_success=$(($test_success + 1))
313 say_color "" "ok $test_count - $@"
316 test_failure_ () {
317 test_failure=$(($test_failure + 1))
318 say_color error "not ok $test_count - $1"
319 shift
320 printf '%s\n' "$*" | sed -e 's/^/# /'
321 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
324 test_known_broken_ok_ () {
325 test_fixed=$(($test_fixed+1))
326 say_color error "ok $test_count - $@ # TODO known breakage vanished"
329 test_known_broken_failure_ () {
330 test_broken=$(($test_broken+1))
331 say_color warn "not ok $test_count - $@ # TODO known breakage"
334 test_debug () {
335 test "$debug" = "" || eval "$1"
338 match_pattern_list () {
339 arg="$1"
340 shift
341 test -z "$*" && return 1
342 for pattern_
344 case "$arg" in
345 $pattern_)
346 return 0
347 esac
348 done
349 return 1
352 match_test_selector_list () {
353 title="$1"
354 shift
355 arg="$1"
356 shift
357 test -z "$1" && return 0
359 # Both commas and whitespace are accepted as separators.
360 OLDIFS=$IFS
361 IFS=' ,'
362 set -- $1
363 IFS=$OLDIFS
365 # If the first selector is negative we include by default.
366 include=
367 case "$1" in
368 !*) include=t ;;
369 esac
371 for selector
373 orig_selector=$selector
375 positive=t
376 case "$selector" in
378 positive=
379 selector=${selector##?}
381 esac
383 test -z "$selector" && continue
385 case "$selector" in
386 *-*)
387 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
388 then
389 echo "error: $title: invalid non-numeric in range" \
390 "start: '$orig_selector'" >&2
391 exit 1
393 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
394 then
395 echo "error: $title: invalid non-numeric in range" \
396 "end: '$orig_selector'" >&2
397 exit 1
401 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
402 then
403 echo "error: $title: invalid non-numeric in test" \
404 "selector: '$orig_selector'" >&2
405 exit 1
407 esac
409 # Short cut for "obvious" cases
410 test -z "$include" && test -z "$positive" && continue
411 test -n "$include" && test -n "$positive" && continue
413 case "$selector" in
415 if test $arg -le ${selector#-}
416 then
417 include=$positive
421 if test $arg -ge ${selector%-}
422 then
423 include=$positive
426 *-*)
427 if test ${selector%%-*} -le $arg \
428 && test $arg -le ${selector#*-}
429 then
430 include=$positive
434 if test $arg -eq $selector
435 then
436 include=$positive
439 esac
440 done
442 test -n "$include"
445 maybe_teardown_verbose () {
446 test -z "$verbose_only" && return
447 exec 4>/dev/null 3>/dev/null
448 verbose=
451 last_verbose=t
452 maybe_setup_verbose () {
453 test -z "$verbose_only" && return
454 if match_pattern_list $test_count $verbose_only
455 then
456 exec 4>&2 3>&1
457 # Emit a delimiting blank line when going from
458 # non-verbose to verbose. Within verbose mode the
459 # delimiter is printed by test_expect_*. The choice
460 # of the initial $last_verbose is such that before
461 # test 1, we do not print it.
462 test -z "$last_verbose" && echo >&3 ""
463 verbose=t
464 else
465 exec 4>/dev/null 3>/dev/null
466 verbose=
468 last_verbose=$verbose
471 maybe_teardown_valgrind () {
472 test -z "$GIT_VALGRIND" && return
473 GIT_VALGRIND_ENABLED=
476 maybe_setup_valgrind () {
477 test -z "$GIT_VALGRIND" && return
478 if test -z "$valgrind_only"
479 then
480 GIT_VALGRIND_ENABLED=t
481 return
483 GIT_VALGRIND_ENABLED=
484 if match_pattern_list $test_count $valgrind_only
485 then
486 GIT_VALGRIND_ENABLED=t
490 # This is a separate function because some tests use
491 # "return" to end a test_expect_success block early
492 # (and we want to make sure we run any cleanup like
493 # "set +x").
494 test_eval_inner_ () {
495 # Do not add anything extra (including LF) after '$*'
496 eval "
497 test \"$trace\" = t && set -x
501 test_eval_ () {
502 # We run this block with stderr redirected to avoid extra cruft
503 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
504 # the shell from printing the "set +x" to turn it off (nor the saving
505 # of $? before that). But we can make sure that the output goes to
506 # /dev/null.
508 # The test itself is run with stderr put back to &4 (so either to
509 # /dev/null, or to the original stderr if --verbose was used).
511 test_eval_inner_ "$@" </dev/null >&3 2>&4
512 test_eval_ret_=$?
513 if test "$trace" = t
514 then
515 set +x
516 if test "$test_eval_ret_" != 0
517 then
518 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
521 } 2>/dev/null
522 return $test_eval_ret_
525 test_run_ () {
526 test_cleanup=:
527 expecting_failure=$2
528 setup_malloc_check
529 test_eval_ "$1"
530 eval_ret=$?
531 teardown_malloc_check
533 if test -z "$immediate" || test $eval_ret = 0 ||
534 test -n "$expecting_failure" && test "$test_cleanup" != ":"
535 then
536 setup_malloc_check
537 test_eval_ "$test_cleanup"
538 teardown_malloc_check
540 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
541 then
542 echo ""
544 return "$eval_ret"
547 test_start_ () {
548 test_count=$(($test_count+1))
549 maybe_setup_verbose
550 maybe_setup_valgrind
553 test_finish_ () {
554 echo >&3 ""
555 maybe_teardown_valgrind
556 maybe_teardown_verbose
559 test_skip () {
560 to_skip=
561 skipped_reason=
562 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
563 then
564 to_skip=t
565 skipped_reason="GIT_SKIP_TESTS"
567 if test -z "$to_skip" && test -n "$test_prereq" &&
568 ! test_have_prereq "$test_prereq"
569 then
570 to_skip=t
572 of_prereq=
573 if test "$missing_prereq" != "$test_prereq"
574 then
575 of_prereq=" of $test_prereq"
577 skipped_reason="missing $missing_prereq${of_prereq}"
579 if test -z "$to_skip" && test -n "$run_list" &&
580 ! match_test_selector_list '--run' $test_count "$run_list"
581 then
582 to_skip=t
583 skipped_reason="--run"
586 case "$to_skip" in
588 say_color skip >&3 "skipping test: $@"
589 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
590 : true
593 false
595 esac
598 # stub; perf-lib overrides it
599 test_at_end_hook_ () {
603 test_done () {
604 GIT_EXIT_OK=t
606 if test -z "$HARNESS_ACTIVE"
607 then
608 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
609 mkdir -p "$test_results_dir"
610 base=${0##*/}
611 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
613 cat >>"$test_results_path" <<-EOF
614 total $test_count
615 success $test_success
616 fixed $test_fixed
617 broken $test_broken
618 failed $test_failure
623 if test "$test_fixed" != 0
624 then
625 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
627 if test "$test_broken" != 0
628 then
629 say_color warn "# still have $test_broken known breakage(s)"
631 if test "$test_broken" != 0 || test "$test_fixed" != 0
632 then
633 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
634 msg="remaining $test_remaining test(s)"
635 else
636 test_remaining=$test_count
637 msg="$test_count test(s)"
639 case "$test_failure" in
641 # Maybe print SKIP message
642 if test -n "$skip_all" && test $test_count -gt 0
643 then
644 error "Can't use skip_all after running some tests"
646 test -z "$skip_all" || skip_all=" # SKIP $skip_all"
648 if test $test_external_has_tap -eq 0
649 then
650 if test $test_remaining -gt 0
651 then
652 say_color pass "# passed all $msg"
654 say "1..$test_count$skip_all"
657 test -d "$remove_trash" &&
658 cd "$(dirname "$remove_trash")" &&
659 rm -rf "$(basename "$remove_trash")"
661 test_at_end_hook_
663 exit 0 ;;
666 if test $test_external_has_tap -eq 0
667 then
668 say_color error "# failed $test_failure among $msg"
669 say "1..$test_count"
672 exit 1 ;;
674 esac
677 if test -n "$valgrind"
678 then
679 make_symlink () {
680 test -h "$2" &&
681 test "$1" = "$(readlink "$2")" || {
682 # be super paranoid
683 if mkdir "$2".lock
684 then
685 rm -f "$2" &&
686 ln -s "$1" "$2" &&
687 rm -r "$2".lock
688 else
689 while test -d "$2".lock
691 say "Waiting for lock on $2."
692 sleep 1
693 done
698 make_valgrind_symlink () {
699 # handle only executables, unless they are shell libraries that
700 # need to be in the exec-path.
701 test -x "$1" ||
702 test "# " = "$(head -c 2 <"$1")" ||
703 return;
705 base=$(basename "$1")
706 symlink_target=$GIT_BUILD_DIR/$base
707 # do not override scripts
708 if test -x "$symlink_target" &&
709 test ! -d "$symlink_target" &&
710 test "#!" != "$(head -c 2 < "$symlink_target")"
711 then
712 symlink_target=../valgrind.sh
714 case "$base" in
715 *.sh|*.perl)
716 symlink_target=../unprocessed-script
717 esac
718 # create the link, or replace it if it is out of date
719 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
722 # override all git executables in TEST_DIRECTORY/..
723 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
724 mkdir -p "$GIT_VALGRIND"/bin
725 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
727 make_valgrind_symlink $file
728 done
729 # special-case the mergetools loadables
730 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
731 OLDIFS=$IFS
732 IFS=:
733 for path in $PATH
735 ls "$path"/git-* 2> /dev/null |
736 while read file
738 make_valgrind_symlink "$file"
739 done
740 done
741 IFS=$OLDIFS
742 PATH=$GIT_VALGRIND/bin:$PATH
743 GIT_EXEC_PATH=$GIT_VALGRIND/bin
744 export GIT_VALGRIND
745 GIT_VALGRIND_MODE="$valgrind"
746 export GIT_VALGRIND_MODE
747 GIT_VALGRIND_ENABLED=t
748 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
749 export GIT_VALGRIND_ENABLED
750 elif test -n "$GIT_TEST_INSTALLED"
751 then
752 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
753 error "Cannot run git from $GIT_TEST_INSTALLED."
754 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
755 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
756 else # normal case, use ../bin-wrappers only unless $with_dashes:
757 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
758 if ! test -x "$git_bin_dir/git"
759 then
760 if test -z "$with_dashes"
761 then
762 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
764 with_dashes=t
766 PATH="$git_bin_dir:$PATH"
767 GIT_EXEC_PATH=$GIT_BUILD_DIR
768 if test -n "$with_dashes"
769 then
770 PATH="$GIT_BUILD_DIR:$PATH"
773 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
774 GIT_CONFIG_NOSYSTEM=1
775 GIT_ATTR_NOSYSTEM=1
776 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
778 if test -z "$GIT_TEST_CMP"
779 then
780 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
781 then
782 GIT_TEST_CMP="$DIFF -c"
783 else
784 GIT_TEST_CMP="$DIFF -u"
788 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
789 export GITPERLLIB
790 test -d "$GIT_BUILD_DIR"/templates/blt || {
791 error "You haven't built things yet, have you?"
794 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
795 then
796 echo >&2 'You need to build test-chmtime:'
797 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
798 exit 1
801 # Test repository
802 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
803 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
804 case "$TRASH_DIRECTORY" in
805 /*) ;; # absolute path is good
806 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
807 esac
808 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
809 rm -fr "$TRASH_DIRECTORY" || {
810 GIT_EXIT_OK=t
811 echo >&5 "FATAL: Cannot prepare test area"
812 exit 1
815 HOME="$TRASH_DIRECTORY"
816 GNUPGHOME="$HOME/gnupg-home-not-used"
817 export HOME GNUPGHOME
819 # run the tput tests *after* changing HOME (in case ncurses needs
820 # ~/.terminfo for $TERM)
821 test -n "${color+set}" || test "x$ORIGINAL_TERM" != "xdumb" && (
822 TERM=$ORIGINAL_TERM &&
823 export TERM &&
824 test -t 1 &&
825 tput bold >/dev/null 2>&1 &&
826 tput setaf 1 >/dev/null 2>&1 &&
827 tput sgr0 >/dev/null 2>&1
828 ) &&
829 color=t
831 if test -n "$color"
832 then
833 say_color () {
835 TERM=$ORIGINAL_TERM
836 export TERM
837 case "$1" in
838 error)
839 tput bold; tput setaf 1;; # bold red
840 skip)
841 tput setaf 4;; # blue
842 warn)
843 tput setaf 3;; # brown/yellow
844 pass)
845 tput setaf 2;; # green
846 info)
847 tput setaf 6;; # cyan
849 test -n "$quiet" && return;;
850 esac
851 shift
852 printf "%s" "$*"
853 tput sgr0
854 echo
857 else
858 say_color() {
859 test -z "$1" && test -n "$quiet" && return
860 shift
861 printf "%s\n" "$*"
865 if test -z "$TEST_NO_CREATE_REPO"
866 then
867 test_create_repo "$TRASH_DIRECTORY"
868 else
869 mkdir -p "$TRASH_DIRECTORY"
871 # Use -P to resolve symlinks in our working directory so that the cwd
872 # in subprocesses like git equals our $PWD (for pathname comparisons).
873 cd -P "$TRASH_DIRECTORY" || exit 1
875 this_test=${0##*/}
876 this_test=${this_test%%-*}
877 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
878 then
879 say_color info >&3 "skipping test $this_test altogether"
880 skip_all="skip all tests in $this_test"
881 test_done
884 # Provide an implementation of the 'yes' utility
885 yes () {
886 if test $# = 0
887 then
889 else
890 y="$*"
893 while echo "$y"
896 done
899 # Fix some commands on Windows
900 case $(uname -s) in
901 *MINGW*)
902 # Windows has its own (incompatible) sort and find
903 sort () {
904 /usr/bin/sort "$@"
906 find () {
907 /usr/bin/find "$@"
909 sum () {
910 md5sum "$@"
912 # git sees Windows-style pwd
913 pwd () {
914 builtin pwd -W
916 # no POSIX permissions
917 # backslashes in pathspec are converted to '/'
918 # exec does not inherit the PID
919 test_set_prereq MINGW
920 test_set_prereq NATIVE_CRLF
921 test_set_prereq SED_STRIPS_CR
922 test_set_prereq GREP_STRIPS_CR
923 GIT_TEST_CMP=mingw_test_cmp
925 *CYGWIN*)
926 test_set_prereq POSIXPERM
927 test_set_prereq EXECKEEPSPID
928 test_set_prereq CYGWIN
929 test_set_prereq SED_STRIPS_CR
930 test_set_prereq GREP_STRIPS_CR
933 test_set_prereq POSIXPERM
934 test_set_prereq BSLASHPSPEC
935 test_set_prereq EXECKEEPSPID
937 esac
939 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
940 test -z "$NO_PERL" && test_set_prereq PERL
941 test -z "$NO_PYTHON" && test_set_prereq PYTHON
942 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
943 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
945 # Can we rely on git's output in the C locale?
946 if test -n "$GETTEXT_POISON"
947 then
948 GIT_GETTEXT_POISON=YesPlease
949 export GIT_GETTEXT_POISON
950 test_set_prereq GETTEXT_POISON
951 else
952 test_set_prereq C_LOCALE_OUTPUT
955 # Use this instead of test_cmp to compare files that contain expected and
956 # actual output from git commands that can be translated. When running
957 # under GETTEXT_POISON this pretends that the command produced expected
958 # results.
959 test_i18ncmp () {
960 test -n "$GETTEXT_POISON" || test_cmp "$@"
963 # Use this instead of "grep expected-string actual" to see if the
964 # output from a git command that can be translated either contains an
965 # expected string, or does not contain an unwanted one. When running
966 # under GETTEXT_POISON this pretends that the command produced expected
967 # results.
968 test_i18ngrep () {
969 if test -n "$GETTEXT_POISON"
970 then
971 : # pretend success
972 elif test "x!" = "x$1"
973 then
974 shift
975 ! grep "$@"
976 else
977 grep "$@"
981 test_lazy_prereq PIPE '
982 # test whether the filesystem supports FIFOs
983 case $(uname -s) in
984 CYGWIN*)
985 false
988 rm -f testfifo && mkfifo testfifo
990 esac
993 test_lazy_prereq SYMLINKS '
994 # test whether the filesystem supports symbolic links
995 ln -s x y && test -h y
998 test_lazy_prereq FILEMODE '
999 test "$(git config --bool core.filemode)" = true
1002 test_lazy_prereq CASE_INSENSITIVE_FS '
1003 echo good >CamelCase &&
1004 echo bad >camelcase &&
1005 test "$(cat CamelCase)" != good
1008 test_lazy_prereq UTF8_NFD_TO_NFC '
1009 # check whether FS converts nfd unicode to nfc
1010 auml=$(printf "\303\244")
1011 aumlcdiar=$(printf "\141\314\210")
1012 >"$auml" &&
1013 case "$(echo *)" in
1014 "$aumlcdiar")
1015 true ;;
1017 false ;;
1018 esac
1021 test_lazy_prereq AUTOIDENT '
1022 sane_unset GIT_AUTHOR_NAME &&
1023 sane_unset GIT_AUTHOR_EMAIL &&
1024 git var GIT_AUTHOR_IDENT
1027 test_lazy_prereq EXPENSIVE '
1028 test -n "$GIT_TEST_LONG"
1031 test_lazy_prereq USR_BIN_TIME '
1032 test -x /usr/bin/time
1035 test_lazy_prereq NOT_ROOT '
1036 uid=$(id -u) &&
1037 test "$uid" != 0
1040 # On a filesystem that lacks SANITY, a file can be deleted even if
1041 # the containing directory doesn't have write permissions, or a file
1042 # can be accessed even if the containing directory doesn't have read
1043 # or execute permissions, causing our tests that validate that Git
1044 # works sensibly in such situations.
1045 test_lazy_prereq SANITY '
1046 mkdir SANETESTD.1 SANETESTD.2 &&
1048 chmod +w SANETESTD.1 SANETESTD.2 &&
1049 >SANETESTD.1/x 2>SANETESTD.2/x &&
1050 chmod -w SANETESTD.1 &&
1051 chmod -rx SANETESTD.2 ||
1052 error "bug in test sript: cannot prepare SANETESTD"
1054 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1055 status=$?
1057 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1058 rm -rf SANETESTD.1 SANETESTD.2 ||
1059 error "bug in test sript: cannot clean SANETESTD"
1060 return $status
1063 GIT_UNZIP=${GIT_UNZIP:-unzip}
1064 test_lazy_prereq UNZIP '
1065 "$GIT_UNZIP" -v
1066 test $? -ne 127